!cpu 6510
!convtab scr

tmpa       = $02
num_fills  = $03
dst        = $04
src        = $06

fcnt_l     = dst
fcnt_h     = dst+1

starty     = src

fill_code  = $08     ;location of inner loop

;SPACE      = 1

bank1      = $0800
bank2      = $2000

chunkl     = $0080
maskr      = $0280
inner_code = $ff9c

n_slopes   = 256

         * = $1000
;--------------------------
;SPEEDCODE SEGMENTS
;
;--------------------------

;format of jump table:
;
;$4000 - $4100 jumps to all lines starting at x = 0
;$4100 - $4200 jumps to all lines starting at x = 8
;...
;per table:
;$80 bytes with one jump (bank1) per 8 byte
;$80 bytes with one jump (bank2) per 8 byte


!macro comb .addr {
         and maskr-$80,x
         ora .addr,y
         sta .addr,y
         jmp f_back
}

!macro norm .addr, .num {
         ;left chunck
;can be savely removed if faces are drawn well sorted from left to right! Work is done by cube.c for us.
;         ora .addr,y
         sta .addr,y

         lda #$ff
!set .addr_ = .addr
!for .x, .num {
         !set .addr_ = .addr_ + $80
         sta .addr_,y
}
         !set .addr_ = .addr_ + $80

         ;right chunk
         lda maskr-$80,x
         ;XXX TODO could also be omitted in certain cases, if no collision to right side occurs (all more than 8 pixels away/outside of corridor)
         ora .addr_,y
         sta .addr_,y
         jmp f_back
}

;speedcode chunks that are jumped to from inner loop
;s0_0_b1
;         +comb bank1+$000
;s0_1_b1
;         +norm bank1+$000, 0
;s0_2_b1
;         +norm bank1+$000, 1
;s0_3_b1
;         +norm bank1+$000, 2
;s0_4_b1
;         +norm bank1+$000, 3
;s0_5_b1
;         +norm bank1+$000, 4
;s0_6_b1
;         +norm bank1+$000, 5
;s0_7_b1
;         +norm bank1+$000, 6
;s0_8_b1
;         +norm bank1+$000, 7
;s0_9_b1
;         +norm bank1+$000, 8
;s0_a_b1
;         +norm bank1+$000, 9
;s0_b_b1
;         +norm bank1+$000, 10
;s0_c_b1
;         +norm bank1+$000, 11
;s0_d_b1
;         +norm bank1+$000, 12
;s0_e_b1
;         +norm bank1+$000, 13
;s0_f_b1
;         +norm bank1+$000, 14

s1_1_b1
         +comb bank1+$080
s1_2_b1
         +norm bank1+$080, 0
s1_3_b1
         +norm bank1+$080, 1
s1_4_b1
         +norm bank1+$080, 2
s1_5_b1
         +norm bank1+$080, 3
s1_6_b1
         +norm bank1+$080, 4
;s1_7_b1
;         +norm bank1+$080, 5
;s1_8_b1
;         +norm bank1+$080, 6
;s1_9_b1
;         +norm bank1+$080, 7
;s1_a_b1
;         +norm bank1+$080, 8
;s1_b_b1
;         +norm bank1+$080, 9
;s1_c_b1
;         +norm bank1+$080, 10
;s1_d_b1
;         +norm bank1+$080, 11
;s1_e_b1
;         +norm bank1+$080, 12
;s1_f_b1
;         +norm bank1+$080, 13


s2_2_b1
         +comb bank1+$100
s2_3_b1
         +norm bank1+$100, 0
s2_4_b1
         +norm bank1+$100, 1
s2_5_b1
         +norm bank1+$100, 2
s2_6_b1
         +norm bank1+$100, 3
s2_7_b1
         +norm bank1+$100, 4
;s2_8_b1
;         +norm bank1+$100, 5
;s2_9_b1
;         +norm bank1+$100, 6
;s2_a_b1
;         +norm bank1+$100, 7
;s2_b_b1
;         +norm bank1+$100, 8
;s2_c_b1
;         +norm bank1+$100, 9
;s2_d_b1
;         +norm bank1+$100, 10
;s2_e_b1
;         +norm bank1+$100, 11
;s2_f_b1
;         +norm bank1+$100, 12


s3_3_b1
         +comb bank1+$180
s3_4_b1
         +norm bank1+$180, 0
s3_5_b1
         +norm bank1+$180, 1
s3_6_b1
         +norm bank1+$180, 2
s3_7_b1
         +norm bank1+$180, 3
s3_8_b1
         +norm bank1+$180, 4
;s3_9_b1
;         +norm bank1+$180, 5
;s3_a_b1
;         +norm bank1+$180, 6
;s3_b_b1
;         +norm bank1+$180, 7
;s3_c_b1
;         +norm bank1+$180, 8
;s3_d_b1
;         +norm bank1+$180, 9
;s3_e_b1
;         +norm bank1+$180, 10
;s3_f_b1
;         +norm bank1+$180, 11


s4_4_b1
         +comb bank1+$200
s4_5_b1
         +norm bank1+$200, 0
s4_6_b1
         +norm bank1+$200, 1
s4_7_b1
         +norm bank1+$200, 2
s4_8_b1
         +norm bank1+$200, 3
s4_9_b1
         +norm bank1+$200, 4
;s4_a_b1
;         +norm bank1+$200, 5
;s4_b_b1
;         +norm bank1+$200, 6
;s4_c_b1
;         +norm bank1+$200, 7
;s4_d_b1
;         +norm bank1+$200, 8
;s4_e_b1
;         +norm bank1+$200, 9
;s4_f_b1
;         +norm bank1+$200, 10


s5_5_b1
         +comb bank1+$280
s5_6_b1
         +norm bank1+$280, 0
s5_7_b1
         +norm bank1+$280, 1
s5_8_b1
         +norm bank1+$280, 2
s5_9_b1
         +norm bank1+$280, 3
s5_a_b1
         +norm bank1+$280, 4
;s5_b_b1
;         +norm bank1+$280, 5
;s5_c_b1
;         +norm bank1+$280, 6
;s5_d_b1
;         +norm bank1+$280, 7
;s5_e_b1
;         +norm bank1+$280, 8
;s5_f_b1
;         +norm bank1+$280, 9


s6_6_b1
         +comb bank1+$300
s6_7_b1
         +norm bank1+$300, 0
s6_8_b1
         +norm bank1+$300, 1
s6_9_b1
         +norm bank1+$300, 2
s6_a_b1
         +norm bank1+$300, 3
s6_b_b1
         +norm bank1+$300, 4
;s6_c_b1
;         +norm bank1+$300, 5
;s6_d_b1
;         +norm bank1+$300, 6
;s6_e_b1
;         +norm bank1+$300, 7
;s6_f_b1
;         +norm bank1+$300, 8


s7_7_b1
         +comb bank1+$380
s7_8_b1
         +norm bank1+$380, 0
s7_9_b1
         +norm bank1+$380, 1
s7_a_b1
         +norm bank1+$380, 2
s7_b_b1
         +norm bank1+$380, 3
s7_c_b1
         +norm bank1+$380, 4
;s7_d_b1
;         +norm bank1+$380, 5
;s7_e_b1
;         +norm bank1+$380, 6
;s7_f_b1
;         +norm bank1+$380, 7


s8_8_b1
         +comb bank1+$400
s8_9_b1
         +norm bank1+$400, 0
s8_a_b1
         +norm bank1+$400, 1
s8_b_b1
         +norm bank1+$400, 2
s8_c_b1
         +norm bank1+$400, 3
s8_d_b1
         +norm bank1+$400, 4
;s8_e_b1
;         +norm bank1+$400, 5
;s8_f_b1
;         +norm bank1+$400, 6

s9_9_b1
         +comb bank1+$480
s9_a_b1
         +norm bank1+$480, 0
s9_b_b1
         +norm bank1+$480, 1
s9_c_b1
         +norm bank1+$480, 2
s9_d_b1
         +norm bank1+$480, 3
s9_e_b1
         +norm bank1+$480, 4
;s9_f_b1
;         +norm bank1+$480, 5


sa_a_b1
         +comb bank1+$500
sa_b_b1
         +norm bank1+$500, 0
sa_c_b1
         +norm bank1+$500, 1
sa_d_b1
         +norm bank1+$500, 2
sa_e_b1
         +norm bank1+$500, 3
sa_f_b1
         +norm bank1+$500, 4


sb_b_b1
         +comb bank1+$580
sb_c_b1
         +norm bank1+$580, 0
sb_d_b1
         +norm bank1+$580, 1
sb_e_b1
         +norm bank1+$580, 2
sb_f_b1
         +norm bank1+$580, 3


sc_c_b1
         +comb bank1+$600
sc_d_b1
         +norm bank1+$600, 0
sc_e_b1
         +norm bank1+$600, 1
sc_f_b1
         +norm bank1+$600, 2


sd_d_b1
         +comb bank1+$680
sd_e_b1
         +norm bank1+$680, 0
sd_f_b1
         +norm bank1+$680, 1


se_e_b1
         +comb bank1+$700
se_f_b1
         +norm bank1+$700, 0

sf_f_b1
         +comb bank1+$780

;s0_0_b2
;         +comb bank2+$000
;s0_1_b2
;         +norm bank2+$000, 0
;s0_2_b2
;         +norm bank2+$000, 1
;s0_3_b2
;         +norm bank2+$000, 2
;s0_4_b2
;         +norm bank2+$000, 3
;s0_5_b2
;         +norm bank2+$000, 4
;s0_6_b2
;         +norm bank2+$000, 5
;s0_7_b2
;         +norm bank2+$000, 6
;s0_8_b2
;         +norm bank2+$000, 7
;s0_9_b2
;         +norm bank2+$000, 8
;s0_a_b2
;         +norm bank2+$000, 9
;s0_b_b2
;         +norm bank2+$000, 10
;s0_c_b2
;         +norm bank2+$000, 11
;s0_d_b2
;         +norm bank2+$000, 12
;s0_e_b2
;         +norm bank2+$000, 13
;s0_f_b2
;         +norm bank2+$000, 14



s1_1_b2
         +comb bank2+$080
s1_2_b2
         +norm bank2+$080, 0
s1_3_b2
         +norm bank2+$080, 1
s1_4_b2
         +norm bank2+$080, 2
s1_5_b2
         +norm bank2+$080, 3
s1_6_b2
         +norm bank2+$080, 4
;s1_7_b2
;         +norm bank2+$080, 5
;s1_8_b2
;         +norm bank2+$080, 6
;s1_9_b2
;         +norm bank2+$080, 7
;s1_a_b2
;         +norm bank2+$080, 8
;s1_b_b2
;         +norm bank2+$080, 9
;s1_c_b2
;         +norm bank2+$080, 10
;s1_d_b2
;         +norm bank2+$080, 11
;s1_e_b2
;         +norm bank2+$080, 12
;s1_f_b2
;         +norm bank2+$080, 13



s2_2_b2
         +comb bank2+$100
s2_3_b2
         +norm bank2+$100, 0
s2_4_b2
         +norm bank2+$100, 1
s2_5_b2
         +norm bank2+$100, 2
s2_6_b2
         +norm bank2+$100, 3
s2_7_b2
         +norm bank2+$100, 4
;s2_8_b2
;         +norm bank2+$100, 5
;s2_9_b2
;         +norm bank2+$100, 6
;s2_a_b2
;         +norm bank2+$100, 7
;s2_b_b2
;         +norm bank2+$100, 8
;s2_c_b2
;         +norm bank2+$100, 9
;s2_d_b2
;         +norm bank2+$100, 10
;s2_e_b2
;         +norm bank2+$100, 11
;s2_f_b2
;         +norm bank2+$100, 12



s3_3_b2
         +comb bank2+$180
s3_4_b2
         +norm bank2+$180, 0
s3_5_b2
         +norm bank2+$180, 1
s3_6_b2
         +norm bank2+$180, 2
s3_7_b2
         +norm bank2+$180, 3
s3_8_b2
         +norm bank2+$180, 4
;s3_9_b2
;         +norm bank2+$180, 5
;s3_a_b2
;         +norm bank2+$180, 6
;s3_b_b2
;         +norm bank2+$180, 7
;s3_c_b2
;         +norm bank2+$180, 8
;s3_d_b2
;         +norm bank2+$180, 9
;s3_e_b2
;         +norm bank2+$180, 10
;s3_f_b2
;         +norm bank2+$180, 11



s4_4_b2
         +comb bank2+$200
s4_5_b2
         +norm bank2+$200, 0
s4_6_b2
         +norm bank2+$200, 1
s4_7_b2
         +norm bank2+$200, 2
s4_8_b2
         +norm bank2+$200, 3
s4_9_b2
         +norm bank2+$200, 4
;s4_a_b2
;         +norm bank2+$200, 5
;s4_b_b2
;         +norm bank2+$200, 6
;s4_c_b2
;         +norm bank2+$200, 7
;s4_d_b2
;         +norm bank2+$200, 8
;s4_e_b2
;         +norm bank2+$200, 9
;s4_f_b2
;         +norm bank2+$200, 10



s5_5_b2
         +comb bank2+$280
s5_6_b2
         +norm bank2+$280, 0
s5_7_b2
         +norm bank2+$280, 1
s5_8_b2
         +norm bank2+$280, 2
s5_9_b2
         +norm bank2+$280, 3
s5_a_b2
         +norm bank2+$280, 4
;s5_b_b2
;         +norm bank2+$280, 5
;s5_c_b2
;         +norm bank2+$280, 6
;s5_d_b2
;         +norm bank2+$280, 7
;s5_e_b2
;         +norm bank2+$280, 8
;s5_f_b2
;         +norm bank2+$280, 9



s6_6_b2
         +comb bank2+$300
s6_7_b2
         +norm bank2+$300, 0
s6_8_b2
         +norm bank2+$300, 1
s6_9_b2
         +norm bank2+$300, 2
s6_a_b2
         +norm bank2+$300, 3
s6_b_b2
         +norm bank2+$300, 4
;s6_c_b2
;         +norm bank2+$300, 5
;s6_d_b2
;         +norm bank2+$300, 6
;s6_e_b2
;         +norm bank2+$300, 7
;s6_f_b2
;         +norm bank2+$300, 8



s7_7_b2
         +comb bank2+$380
s7_8_b2
         +norm bank2+$380, 0
s7_9_b2
         +norm bank2+$380, 1
s7_a_b2
         +norm bank2+$380, 2
s7_b_b2
         +norm bank2+$380, 3
s7_c_b2
         +norm bank2+$380, 4
;s7_d_b2
;         +norm bank2+$380, 5
;s7_e_b2
;         +norm bank2+$380, 6
;s7_f_b2
;         +norm bank2+$380, 7



s8_8_b2
         +comb bank2+$400
s8_9_b2
         +norm bank2+$400, 0
s8_a_b2
         +norm bank2+$400, 1
s8_b_b2
         +norm bank2+$400, 2
s8_c_b2
         +norm bank2+$400, 3
s8_d_b2
         +norm bank2+$400, 4
;s8_e_b2
;         +norm bank2+$400, 5
;s8_f_b2
;         +norm bank2+$400, 6



s9_9_b2
         +comb bank2+$480
s9_a_b2
         +norm bank2+$480, 0
s9_b_b2
         +norm bank2+$480, 1
s9_c_b2
         +norm bank2+$480, 2
s9_d_b2
         +norm bank2+$480, 3
s9_e_b2
         +norm bank2+$480, 4
;s9_f_b2
;         +norm bank2+$480, 5


sa_a_b2
         +comb bank2+$500
sa_b_b2
         +norm bank2+$500, 0
sa_c_b2
         +norm bank2+$500, 1
sa_d_b2
         +norm bank2+$500, 2
sa_e_b2
         +norm bank2+$500, 3
sa_f_b2
         +norm bank2+$500, 4



sb_b_b2
         +comb bank2+$580
sb_c_b2
         +norm bank2+$580, 0
sb_d_b2
         +norm bank2+$580, 1
sb_e_b2
         +norm bank2+$580, 2
sb_f_b2
         +norm bank2+$580, 3



sc_c_b2
         +comb bank2+$600
sc_d_b2
         +norm bank2+$600, 0
sc_e_b2
         +norm bank2+$600, 1
sc_f_b2
         +norm bank2+$600, 2



sd_d_b2
         +comb bank2+$680
sd_e_b2
         +norm bank2+$680, 0
sd_f_b2
         +norm bank2+$680, 1



se_e_b2
         +comb bank2+$700
se_f_b2
         +norm bank2+$700, 0

sf_f_b2
         +comb bank2+$780

!align 255,0
slope_lo
!bin "slope_indexes.bin",n_slopes,n_slopes
slope_hi
!bin "slope_indexes.bin",n_slopes,0

         * = $2000
screen_setup
         sei
         lda $d011
         bmi *-3
         lda $d011
         bpl *-3
         lda #$0b
         sta $d011

         ldy #$00
-
         lda #$00
         sta $0400,y
         sta $0500,y
         sta $0600,y
         sta $06c0,y

         lda #$02
         sta $d800,y
         sta $d900,y
         sta $da00,y
         sta $db00,y
         dey
         bne -

         ;init irq
         lda #$34
         sta $01

         ;generate mask tables
         jsr setup_fill
         jsr gen_clear

         ;clear a bunch of variables
         lda #$00
         sta num_fills

         ;reset frame counter
         sta fcnt_l
         sta fcnt_h

         ;build 16x16 charset grid
         tax
--
         ldy #$00
         txa
-
scr_     sta $04a2,y
         clc
         adc #$10
         iny
         cpy #$10
         bne -
         lda scr_+1
         clc
         adc #$28
         sta scr_+1
         bcc +
         inc scr_+2
+
         inx
         cpx #$10
         bne --

         ;lda #$78
         ;sta+1 bank
         inc $01
         lda #$7f
         sta $dc0d
         and $d011
         sta $d011
         lda #$2d
         sta $d012
         lda $dc0d
         lda #$01
         sta $d01a
         sta $d019
         lda #<irq1
         sta $fffe
         lda #>irq1
         sta $ffff
         jmp main

;--------------------------
;CLEAR
;clear screenbuffer, FAST and only necessary areas
;--------------------------

;clear only those blocks that the object rotates in (circle with a radius of 128)
;takes ~$57 rasterlines, so not much to bother about

val0     = 63
val1     = 35
val2     = 23
val3     = 16
val4     = 11
val5     = 7
val6     = 5
val7     = 4

val8     = 4
val9     = 5
vala     = 5
valb     = 8
valc     = 11
vald     = 16
vale     = 24
valf     = 37

tab_s
         !byte val0, val1, val2, val3, val4, val5, val6, val7
         !byte val8, val9, vala, valb, valc, vald, vale, valf
tab_e
         !byte 127-val0+0, 127-val1+2, 127-val2+1, 127-val3+1, 127-val4+1, 127-val5+1, 127-val6+1, 127-val7
         !byte 127-val8, 127-val9+1, 127-vala+1, 127-valb+1, 127-valc+1, 127-vald+0, 127-vale+1, 127-valf+3

gen_clear
         lda #<start_clear
         sta dst
         lda #>start_clear
         sta dst+1

         ldy #$00
         lda #<bank1+$80
         sta src
         lda #>bank1
         sta src+1
         jsr make_bank

         lda dst
         sta clear2+1
         lda dst+1
         sta clear2+2

         ldy #$00
         lda #<bank2+$80
         sta src
         lda #>bank2
         sta src+1
         jmp make_bank

make_bank
         ldx #$01
--
         lda tab_e,x
         ora src
         sta cl_lst+1
         lda tab_s,x
         ora src
         sta src
-
         ldy #$00
         lda #$8d
         sta (dst),y
         iny
         lda src
         sta (dst),y
         iny
         lda src+1
         sta (dst),y
         lda dst
         clc
         adc #$03
         sta dst
         bcc +
         inc dst+1
+
         cmp #$fc
         bcc +
         lda dst+1
         cmp #$3e
         bcc +
         adc #$00
         and #$03
         bne +
         ldy #$00
         lda #$4c
         sta (dst),y
         iny
         lda #$00
         sta (dst),y
         iny
         lda dst+1
         clc
         adc #$02
         sta (dst),y
         sta dst+1
         lda #$00
         sta dst
+
         inc src
         lda src
cl_lst   cmp #$00
         bne -

         and #$80
         eor #$80
         sta src
         bmi +
         inc src+1
+
         inx
         cpx #$10
         bne --

         ldy #$00
         lda #$60
         sta (dst),y
         inc dst
         bne +
         inc dst+1
+
         rts

;copy a lot of stuff to there needed location and setup the filler code
setup_fill
         ;generate mask tables
         ldx #$00
         txa
-
         ;generate masks
         sta maskr,x    ;use offset of 1, as xend has that offset as well
         eor #$ff
         sta chunkl,x    ;add offset of +$80 as it is added to xstart later on as well
         eor #$ff
         sec
         ror
         cmp #$ff
         bne +
         lda #$00
+
         inx
         bpl -

         ;the filler code, zeropage part
         ldx #$00
-
         lda fill_start,x
         sta fill_code,x
         inx
         cpx #fill_end-fill_start
         bne -

         ;the filler code, end of mem part
         ldx #$00
-
         lda inner_start,x
         sta inner_code,x
         inx
         cpx #inner_end-inner_start
         bne -

         ;copy target pointers for speed_code segments to fit memory layout ($20 pointers each $400 bytes from $c000 on)
         lda #<tgt_bank1
         sta src
         lda #>tgt_bank1
         sta src+1
         lda #$40
         sta dst+1
         lda #$00

         jsr next1

         lda #<tgt_bank2
         sta src
         lda #>tgt_bank2
         sta src+1
         lda #$40
         sta dst+1
         lda #$80
next1
         ldx #$0f
-
         sta dst
         ldy #$00
         lda (src),y
         sta (dst),y
         iny
         lda (src),y
         sta (dst),y
         lda src
         clc
         adc #$02
         sta src
         bcc *+4
         inc src+1
         lda dst
         clc
         adc #$08
         dex
         bpl -
         inc dst+1
         inc dst+1
         inc dst+1
         inc dst+1
         ldx dst+1
         cpx #$80
         beq +
         eor #$80
         and #$80
         jmp next1
+
         rts

;just there to be copied to their final destinations @$ee00-$fe00
;only include line lengths that will be used anyway!
tgt_bank1
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , s1_1_b1, s1_2_b1, s1_3_b1, s1_4_b1, s1_5_b1, s1_6_b1, e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , s2_2_b1, s2_3_b1, s2_4_b1, s2_5_b1, s2_6_b1, s2_7_b1, e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , s3_3_b1, s3_4_b1, s3_5_b1, s3_6_b1, s3_7_b1, s3_8_b1, e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , s4_4_b1, s4_5_b1, s4_6_b1, s4_7_b1, s4_8_b1, s4_9_b1, e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , s5_5_b1, s5_6_b1, s5_7_b1, s5_8_b1, s5_9_b1, s5_a_b1, e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , s6_6_b1, s6_7_b1, s6_8_b1, s6_9_b1, s6_a_b1, s6_b_b1, e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , s7_7_b1, s7_8_b1, s7_9_b1, s7_a_b1, s7_b_b1, s7_c_b1, e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , s8_8_b1, s8_9_b1, s8_a_b1, s8_b_b1, s8_c_b1, s8_d_b1, e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , s9_9_b1, s9_a_b1, s9_b_b1, s9_c_b1, s9_d_b1, s9_e_b1, e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sa_a_b1, sa_b_b1, sa_c_b1, sa_d_b1, sa_e_b1, sa_f_b1
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sb_b_b1, sb_c_b1, sb_d_b1, sb_e_b1, sb_f_b1
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sc_c_b1, sc_d_b1, sc_e_b1, sc_f_b1
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sd_d_b1, sd_e_b1, sd_f_b1
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , se_e_b1, se_f_b1
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sf_f_b1

tgt_bank2
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , s1_1_b2, s1_2_b2, s1_3_b2, s1_4_b2, s1_5_b2, s1_6_b2, e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , s2_2_b2, s2_3_b2, s2_4_b2, s2_5_b2, s2_6_b2, s2_7_b2, e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , s3_3_b2, s3_4_b2, s3_5_b2, s3_6_b2, s3_7_b2, s3_8_b2, e_back , e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , s4_4_b2, s4_5_b2, s4_6_b2, s4_7_b2, s4_8_b2, s4_9_b2, e_back , e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , s5_5_b2, s5_6_b2, s5_7_b2, s5_8_b2, s5_9_b2, s5_a_b2, e_back , e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , s6_6_b2, s6_7_b2, s6_8_b2, s6_9_b2, s6_a_b2, s6_b_b2, e_back , e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , s7_7_b2, s7_8_b2, s7_9_b2, s7_a_b2, s7_b_b2, s7_c_b2, e_back , e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , s8_8_b2, s8_9_b2, s8_a_b2, s8_b_b2, s8_c_b2, s8_d_b2, e_back , e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , s9_9_b2, s9_a_b2, s9_b_b2, s9_c_b2, s9_d_b2, s9_e_b2, e_back 
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sa_a_b2, sa_b_b2, sa_c_b2, sa_d_b2, sa_e_b2, sa_f_b2
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sb_b_b2, sb_c_b2, sb_d_b2, sb_e_b2, sb_f_b2
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sc_c_b2, sc_d_b2, sc_e_b2, sc_f_b2
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sd_d_b2, sd_e_b2, sd_f_b2
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , se_e_b2, se_f_b2
         !word e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , e_back , sf_f_b2

;--------------------------
;FILLER STUFF
;
;--------------------------

;--------------------------
;THE VERY INNER LOOP OF OUR FILLER
;(will be placed into zeropage and $ffxx for max. performance) (and also to save mem 8-)
;--------------------------

inner_start
!pseudopc inner_code {
-
         jmp next_frame
extra_offs
         and #$7f
         sbc #$01               ;subtract one to fix cleared carry @ fill
         ;sec                   ;can't underrun
         sta+1 l_offs           ;store left offset
data10   lda $1002,y            ;and load extra offset
         sta+1 r_offs
         iny
         bne +                  ;does dpos wrap around?
         jsr upd_hi
         bne +
start
data1    lax $1000,y
f_next
         sbx #$80               ;x = x - $ 80 -> sec
         beq -
         stx starty             ;write out x & $7f

data2    lda $1001,y            ;load offset
         bmi extra_offs         ;we have an extra offset for right side?
         sta+1 r_offs           ;nope
         sbc #$01
         ;sec                   ;can't underrun
         sta+1 l_offs
+
data3    ldx $1002,y
         lda slope_lo,x
         ;sec
         sbc starty             ;subtract current y-position from slope-pointer
         sta+1 r_slope+1
         lda slope_hi,x
         sbc #$00
         sta+1 r_slope+2

data4    ldx $1003,y
         lda slope_lo,x
         ;sec                   ;above subtraction always leads to a set carry
         sbc starty             ;subtract current y-position from slope-pointer
         sta+1 l_slope+1
         lda slope_hi,x
         sbc #$00
         sta+1 l_slope+2

data5    lda $1004,y
         sta+1 f_yend

         tya
         adc #$04               ;dpos += 4 + carry + extra offset
         sta+1 dpos
         ldy starty
         iny
         bcc *+24
         ;bcc fill
         jsr upd_hi
         clc
         jmp fill
}
inner_end

;$fffe as address reached, so the bcc fill wraps around, takes 4 cycles but saves us a far branch built from a bcs and jmp

fill_start
!pseudopc fill_code {
f_back                          ;entry point after speedcode segment was executed
e_back                          ;directly jump to here if something is wrong with speedcode setup
         iny
recheck                         ;XXX TODO actually recheck should enter here or else lines are drawn one too far if left and right slope are updated at same time
f_yend = * + 1
         cpy #$00               ;forces carry to be cleared, last line to be rendered until next refill/end
         bcs refill
fill
;-------------------------------------------------------------
l_slope  lda $1000,y            ;load startx for loading chunkl
l_offs = * + 1
         sbc #$00               ;add offset
         sta+1 f_msk+1          ;setup mask without tainting X, expensive, yuck :-( but mask loading therefore happens within 3 cycles
         asr #$f8               ;results in values from $40 .. $7c, just the locations where our tables for (jmp ($xxxx) are placed
         sta+1 f_jmp+2          ;update byte of jump responsible to select all code-segments that start the column corresponding to x

r_slope  lax $1000,y            ;load endx
r_offs = * + 1
         sbx #$00               ;add offset
bank = * + 1
         lda #$78               ;cut back x to a sane value (pointers are at least aligned to even addresses) for jump and select the right bank for free whle doing so (bit 7)
         sax+1 f_jmp+1          ;set up jump

f_msk    lda $00                ;load left chunk from $80 .. $ff -> 3 cycles only \o/
f_jmp    jmp ($1000)            ;do it! \o/
;-------------------------------------------------------------
refill
                                ;carry is set on enter
                                ;get mext refill position
dpos = * + 1
         ldy #$00
data6    lax $1000,y            ;load next refill pos
         bmi *-$76              ;if negative, next face begins
         ;bmi f_next            ;XXX acme needs to be fixed first to make branches with address wrap-around work (jumps from zeropage to last page in mem)

data7    lda $1001,y            ;get x-offset, if negative, then left side is updated
         bpl +
         and #$7f
         sbc #$01               ;need to subtract 1 to fix cleared carry @ fill
         ;sec                   ;can't underrun
         sta+1 l_offs
data8    lda $1002,y            ;keep x, thus use y
         tay
         lda slope_lo,y         ;copy slope-pointer - starty
         ;sec
         sbc+1 f_yend           ;subtract current y-position from slope-pointer
         sta+1 l_slope+1
         lda slope_hi,y
         sbc #$00
         sta+1 l_slope+2

         ldy+1 f_yend           ;restore last y-position before refill
         stx+1 f_yend           ;set next refill position

         lda+1 dpos
         adc #$02
         sta+1 dpos
         bcc fill
         bcs ++                 ;BRA
+
         ;update right side
         ;value is -x & $7f     ;bit 7 defines bank to be rendered to
         sta+1 r_offs
data9    lda $1002,y
         tay
         lda slope_lo,y
         ;sec
         sbc+1 f_yend           ;subtract current y-position from slope-pointer
         sta+1 r_slope+1
         lda slope_hi,y
         sbc #$00
         sta+1 r_slope+2

         ldy+1 f_yend           ;restore last y-position before refill
         stx+1 f_yend           ;set next refill position

         lda+1 dpos             ;dpos += 3
         adc #$02
         sta+1 dpos
         bcc fill
++
         jsr upd_hi
         clc
         bcc fill               ;BRA
;-------------------------------------------------------------
}
fill_end

;--------------------------
;DATA
;
;--------------------------

         * = $2800
slopes
!bin "slopes.bin"

;--------------------------
;MAINCODE
;
;--------------------------

main
         ;clear doublebuffer
         ldy #$00
         tya
         jsr clear_buf

         ldx #>bank2
         stx bdst+2
         jsr clear_buf

         dec $01
         cli
         jmp begin

clear_buf
         ldx #$08
-
bdst     sta bank1,y
         dey
         bne -
         inc bdst+2
         dex
         bne -
         rts

;------------------------
;IRQ HANDLER
;
;------------------------

irq1
         ;handle irq with all roms off
         sta tmpa
         nop
         nop
         nop
         ;lda #$35
         inc $01
         dec $d019
         lda #$f2
         cmp $d012
         beq irq2
         ;set $d018
         sta $d012
.d018    lda #$12
         sta $d018
         inc fcnt_l
         bne +
         inc fcnt_h
+
         lda #$01
         bne +
irq2
         lda #$2d
         sta $d012
         lda #$1b
         sta $d011
         lda #$16
         sta $d018
         lda #$00
+
         sta $d020
         sta $d021
         dec $01
         lda tmpa
         rti

;------------------------
;Filler code
;pointer update and entry
;------------------------

upd_hi
         ;XXX ATTENTION: spoils x, could be harmful
         ldx+1 data6+2
         inx
         stx+1 data6+2
         stx+1 data7+2
         stx+1 data8+2
         stx+1 data9+2
         stx data1+2
         stx data2+2
         stx data3+2
         stx data4+2
         stx data5+2
         stx data10+2
         rts

next_frame
         inc+1 dpos
         bne *+5
         jsr upd_hi
update
         ;switch bank
         ldy #$12
         lda+1 bank
         eor #$80
         sta+1 bank
         bmi *+4
         ldy #$18
         inc $01
         sty .d018+1
         lda #$f0
         cmp $d012
         bcc *+5
         sty $d018
         dec $01

         ;clear new working buffer
clear
         lda #$00
         ldx+1 bank
         bmi clear2
         jsr start_clear
         jmp +
clear2   jsr $1000
+
         inc num_fills
         bne +
         lda fcnt_l
         sta $07e0
         lda fcnt_h
         sta $07e1
         lda #$00
         sta fcnt_l
         sta fcnt_h
         sta num_fills
+
!ifdef SPACE {
         inc $01
-
         lda $dc01
         and #$10
         bne -
-
         lda $dc01
         and #$10
         beq -
         dec $01
}

         lda+1 dpos
         cmp #<data_end
         bne +
         lda+1 data6+2
         cmp #>data_end
         bne +
begin
reset_data_ptr
         lda #<data_start
         sta+1 dpos
         ldx #>data_start
         jsr upd_hi+3
+
         ldy+1 dpos
         jmp start

start_clear

         * = $7d00
data_start
!src "data.asm"
data_end

